<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSetTemperaturesSelection ArrayType
 * @subpackage Arrays
 */
class ArrayOfSetTemperaturesSelection extends AbstractStructArrayBase
{
    /**
     * The SetTemperaturesSelection
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SetTemperaturesSelection[]
     */
    public $SetTemperaturesSelection;
    /**
     * Constructor method for ArrayOfSetTemperaturesSelection
     * @uses ArrayOfSetTemperaturesSelection::setSetTemperaturesSelection()
     * @param \StructType\SetTemperaturesSelection[] $setTemperaturesSelection
     */
    public function __construct(array $setTemperaturesSelection = array())
    {
        $this
            ->setSetTemperaturesSelection($setTemperaturesSelection);
    }
    /**
     * Get SetTemperaturesSelection value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SetTemperaturesSelection[]|null
     */
    public function getSetTemperaturesSelection()
    {
        return isset($this->SetTemperaturesSelection) ? $this->SetTemperaturesSelection : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSetTemperaturesSelection method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSetTemperaturesSelection method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSetTemperaturesSelectionForArrayConstraintsFromSetSetTemperaturesSelection(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSetTemperaturesSelectionSetTemperaturesSelectionItem) {
            // validation for constraint: itemType
            if (!$arrayOfSetTemperaturesSelectionSetTemperaturesSelectionItem instanceof \StructType\SetTemperaturesSelection) {
                $invalidValues[] = is_object($arrayOfSetTemperaturesSelectionSetTemperaturesSelectionItem) ? get_class($arrayOfSetTemperaturesSelectionSetTemperaturesSelectionItem) : sprintf('%s(%s)', gettype($arrayOfSetTemperaturesSelectionSetTemperaturesSelectionItem), var_export($arrayOfSetTemperaturesSelectionSetTemperaturesSelectionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SetTemperaturesSelection property can only contain items of type \StructType\SetTemperaturesSelection, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SetTemperaturesSelection value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SetTemperaturesSelection[] $setTemperaturesSelection
     * @return \ArrayType\ArrayOfSetTemperaturesSelection
     */
    public function setSetTemperaturesSelection(array $setTemperaturesSelection = array())
    {
        // validation for constraint: array
        if ('' !== ($setTemperaturesSelectionArrayErrorMessage = self::validateSetTemperaturesSelectionForArrayConstraintsFromSetSetTemperaturesSelection($setTemperaturesSelection))) {
            throw new \InvalidArgumentException($setTemperaturesSelectionArrayErrorMessage, __LINE__);
        }
        if (is_null($setTemperaturesSelection) || (is_array($setTemperaturesSelection) && empty($setTemperaturesSelection))) {
            unset($this->SetTemperaturesSelection);
        } else {
            $this->SetTemperaturesSelection = $setTemperaturesSelection;
        }
        return $this;
    }
    /**
     * Add item to SetTemperaturesSelection value
     * @throws \InvalidArgumentException
     * @param \StructType\SetTemperaturesSelection $item
     * @return \ArrayType\ArrayOfSetTemperaturesSelection
     */
    public function addToSetTemperaturesSelection(\StructType\SetTemperaturesSelection $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SetTemperaturesSelection) {
            throw new \InvalidArgumentException(sprintf('The SetTemperaturesSelection property can only contain items of type \StructType\SetTemperaturesSelection, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SetTemperaturesSelection[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SetTemperaturesSelection|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SetTemperaturesSelection|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SetTemperaturesSelection|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SetTemperaturesSelection|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SetTemperaturesSelection|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SetTemperaturesSelection
     */
    public function getAttributeName()
    {
        return 'SetTemperaturesSelection';
    }
}
